if [ $# -ne 2 ];
  then 
    echo "Usage: ./make_hilbert_3_whole.sh [-a|-o] theorem_name"
    echo "use -a option for generating files for [-a]ll theorems in the folder"
    echo "use -o option for generating files for [-o]ne specific theorem"
    echo "theorem_names is just th_mg_1a"
  else

    beginning='<xi:include href="'
    end='" parse="xml" xmlns:xi="http://www.w3.org/2003/XInclude"/>'
    if [[ $1 == "-a" ]];
      then
	#use temporary file to save beginning of the file

	#prvi put koristimo > da bi napravio novi fajl
	#nadalje, za dopisivanje koristimo >>
	echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" > temp
	echo "<!DOCTYPE main SYSTEM \"Vernacular.dtd\">" >> temp
	echo "<?xml-stylesheet href=\"VernacularTex.xsl\" type=\"text/xsl\"?>" >> temp
	echo >> temp

        #beggining of the xml file
	echo "<main>" >> temp
	echo >> temp
	echo $beginning"frontpage.xml"$end >> temp
	echo $beginning"theory_trivial.xml"$end >> temp
	echo >> temp
	echo "<chapter name=\"Hilbert\">" >> temp
	echo >> temp
	#add small xml files to a large one

	#dodajemo sve dokaze
	ls proof*.xml > hilbert_whole.xml;
        #dodajemo na pocetak svakog reda
	sed -i -e "s|^|$beginning|" hilbert_whole.xml;
        #dodajemo na kraj svakog reda
	sed -i -e "s|$|$end|" hilbert_whole.xml;

	echo >> hilbert_whole.xml
	echo "</chapter>" >> hilbert_whole.xml
	echo >> hilbert_whole.xml
	echo "</main>" >> hilbert_whole.xml


	cat hilbert_whole.xml >> temp
	mv temp hilbert_whole.xml

      else
	if [[ $1 == "-o" ]] ;
          then

	    #use temporary file to save beginning of the file

	    #prvi put koristimo > da bi napravio novi fajl
	    #nadalje, za dopisivanje koristimo >>
	    echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" > temp
	    echo "<!DOCTYPE main SYSTEM \"Vernacular.dtd\">" >> temp
	    echo "<?xml-stylesheet href=\"VernacularTex.xsl\" type=\"text/xsl\"?>" >> temp
	    echo >> temp

            #beggining of the xml file
	    echo "<main>" >> temp
	    echo >> temp
	    echo $beginning"frontpage.xml"$end >> temp	    
	    echo $beginning"theory_trivial.xml"$end >> temp
	    echo >> temp

	    echo "<chapter name=\"Hilbert\">" >> temp
	    echo >> temp
	    #add small xml files to a large one

	    #dodajemo sve dokaze koji se odnose na tekucu teoremu
	    ls proof_$2_*.xml > $2_complete_proof.xml;
            #dodajemo na pocetak svakog reda
	    sed -i -e "s|^|$beginning|" $2_complete_proof.xml;
            #dodajemo na kraj svakog reda
	    sed -i -e "s|$|$end|" $2_complete_proof.xml;

	    echo >> $2_complete_proof.xml
	    echo "</chapter>" >> $2_complete_proof.xml
	    echo >> $2_complete_proof.xml
	    echo "</main>" >> $2_complete_proof.xml

	    cat $2_complete_proof.xml >> temp
	    mv temp $2_complete_proof.xml
	    
	  else
	    echo "You didn't use correct option."
	    echo "Usage: ./make_hilbert_3_whole.sh [-a|-o] theorem_name"
	    echo "use -a option for generating files for [-a]ll theorems in the folder"
	    echo "use -o option for generating files for [-o]ne specific theorem"
	    echo "theorem_names is just th_mg_1a"       
	fi
    fi
fi