#ifndef _OPSTE_H_
#define _OPSTE_H_

#include <vector>
#include <stdlib.h>
#include <stdio.h>
#include <iostream>
#include <fstream>
#include <cstring>
#include <iomanip>
#include <sys/stat.h>

using namespace std;

int run(char,char*, string, string);

/*
void tptp_run_resolution_then_argo(int reversed, ofstream &aout, 
				   char* teorema, 
				   string vampire_command, 
				   string e_command, 
				   string spass_command,
				   string argoclp_location,
				   vector<string> &minimal_axioms, 
				   string &dokazivac, string &order, 
				   string folder);
*/

void tptp_run_resolution_then_argo(int reversed, ofstream &aout, 
				   char* teorema, 
				   string vampire_command, 
				   string e_command, 
				   string spass_command,
				   vector<string> &minimal_axioms, 
				   string &dokazivac, string &order, 
				   string folder);


//fja koja ce pozivati vise puta sva 3 dokazivaca dok ne dobije 
//minimalan skup aksioma koji dokazuje teoremu
void prove_theorem(int reversed, char* teorema, string vampire_command, 
		   string e_command, string spass_command, 
		   vector<string> &minimal_axioms, string &dokazivac,
		   string &order, float*, float*, float*);

void prove_theorem_once(int reversed, char* teorema, 
			string vampire_command, 
			string e_command, string spass_command, 
			vector<string> &minimal_axioms, string &dokazivac,
			string &order, float*, float*, float*);

//fja koja poziva sva 3 dokazivaca i vraca ime onog koji je dokazao
//teoremu sa najmanjim skupom aksioma
string run_provers(char* teorema, string vampire_command, 
		   string e_command, string spass_command, 
		   vector<string> &minimal_axioms, float*, float*, float*);

//fja koja ako vampire dokaze vraca vreme dokaza i skup aksioma
//a ako ne dokaze vraca negativan broj
float run_vampire(char* teorema, string vampire_command, 
		vector<string> &vampire_axioms);

float run_e(char* teorema, string e_command, vector<string> &e_axioms);

float run_spass(char* teorema, string spass_command, 
	      vector<string> &spass_axioms);

double run_argoclp(char* teorema, string argoclp_command, string proofs);

double tptp_run_argoclp(int reversed, char* teorema, string argoclp_command, string proofs);

string minimal(float, vector<string>, float, vector<string>, float, 
	       vector<string>);

int eliminate_space(char*);

//fja koja poredi vektore, vraca +1 ako je prvi veci od drugog, 
//-1 ako je prvi manji od drugog i 
//0 ako su jednake duzine
// if (compare_vectors(v1, v2) < 0) <=> v1 < v2
int compare_vector_length(vector<string>, vector<string>);

#endif
