theory th_1_complete_proof
imports Main 
begin
typedecl point
typedecl line
typedecl plane

consts eq_point ::  "point \<Rightarrow> point \<Rightarrow>  bool "
consts not_eq_point ::  "point \<Rightarrow> point \<Rightarrow>  bool "
consts eq_line ::  "line \<Rightarrow> line \<Rightarrow>  bool "
consts not_eq_line ::  "line \<Rightarrow> line \<Rightarrow>  bool "
consts eq_plane ::  "plane \<Rightarrow> plane \<Rightarrow>  bool "
consts not_eq_plane ::  "plane \<Rightarrow> plane \<Rightarrow>  bool "
consts inc_po_l ::  "point \<Rightarrow> line \<Rightarrow>  bool "
consts not_inc_po_l ::  "point \<Rightarrow> line \<Rightarrow>  bool "
consts inc_po_pl ::  "point \<Rightarrow> plane \<Rightarrow>  bool "
consts not_inc_po_pl ::  "point \<Rightarrow> plane \<Rightarrow>  bool "
consts inc_l_pl ::  "line \<Rightarrow> plane \<Rightarrow>  bool "
consts not_inc_l_pl ::  "line \<Rightarrow> plane \<Rightarrow>  bool "
consts int_l_l ::  "line \<Rightarrow> line \<Rightarrow>  bool "
consts not_int_l_l ::  "line \<Rightarrow> line \<Rightarrow>  bool "
consts int_l_pl ::  "line \<Rightarrow> plane \<Rightarrow>  bool "
consts not_int_l_pl ::  "line \<Rightarrow> plane \<Rightarrow>  bool "
consts int_pl_pl ::  "plane \<Rightarrow> plane \<Rightarrow>  bool "
consts not_int_pl_pl ::  "plane \<Rightarrow> plane \<Rightarrow>  bool "
consts cop ::  "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow>  bool "
consts not_cop ::  "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow>  bool "
consts col ::  "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow>  bool "
consts not_col ::  "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow>  bool "
consts bet ::  "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow>  bool "
consts not_bet ::  "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow>  bool "
consts cong ::  "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow>  bool "
consts not_cong ::  "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow>  bool "
consts cong_angle ::  "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow>  bool "
consts not_cong_angle ::  "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow>  bool "
consts order ::  "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow>  bool "
consts not_order ::  "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow>  bool "
consts cut ::  "line \<Rightarrow> point \<Rightarrow> point \<Rightarrow>  bool "
consts not_cut ::  "line \<Rightarrow> point \<Rightarrow> point \<Rightarrow>  bool "
consts pash ::  "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> line \<Rightarrow> plane \<Rightarrow>  bool "
consts not_pash ::  "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> line \<Rightarrow> plane \<Rightarrow>  bool "

axiomatization where 

ax_D11b: "\<lbrakk>inc_po_l A q; \<not> inc_po_pl A gamma\<rbrakk> \<Longrightarrow> (\<not> inc_l_pl q gamma)"
and ax_D11: "\<lbrakk>inc_l_pl q gamma; inc_po_l A q\<rbrakk> \<Longrightarrow> (inc_po_pl A gamma)"
and ax_D1a: "\<lbrakk>A ~= B; inc_po_l A s; inc_po_l B s; \<not> inc_po_l C s\<rbrakk> \<Longrightarrow> (\<not> col A B C)"
and ax_D1: "\<lbrakk>inc_po_l A s; inc_po_l B s; inc_po_l C s\<rbrakk> \<Longrightarrow> (col A B C)"
and ax_D2a: "\<lbrakk>A ~= B; inc_po_l A s; inc_po_l B s; \<not> col A B C\<rbrakk> \<Longrightarrow> (\<not> inc_po_l C s)"
and ax_D3a: "\<lbrakk>\<not> col A B C; inc_po_pl A beta1; inc_po_pl B beta1; inc_po_pl C beta1; \<not> inc_po_pl D beta1\<rbrakk> \<Longrightarrow> (\<not> cop A B C D)"
and ax_D3: "\<lbrakk>inc_po_pl A beta1; inc_po_pl B beta1; inc_po_pl C beta1; inc_po_pl D beta1\<rbrakk> \<Longrightarrow> (cop A B C D)"
and ax_D4a: "\<lbrakk>\<not> col A B C; inc_po_pl A beta1; inc_po_pl B beta1; inc_po_pl C beta1; \<not> cop A B C D\<rbrakk> \<Longrightarrow> (\<not> inc_po_pl D beta1)"
and ax_D5a: "\<lbrakk>p ~= q; \<not> int_l_l p q; inc_po_l C p\<rbrakk> \<Longrightarrow> (\<not> inc_po_l C q)"
and ax_D5: "\<lbrakk>p ~= q; inc_po_l C p; inc_po_l C q\<rbrakk> \<Longrightarrow> (int_l_l p q)"
and ax_D7a: "\<lbrakk>alpha ~= beta; inc_po_pl C alpha; \<not> int_pl_pl alpha beta\<rbrakk> \<Longrightarrow> (\<not> inc_po_pl C beta)"
and ax_D7: "\<lbrakk>alpha ~= beta; inc_po_pl C alpha; inc_po_pl C beta\<rbrakk> \<Longrightarrow> (int_pl_pl alpha beta)"
and ax_D9a: "\<lbrakk>\<not> inc_l_pl p beta; \<not> int_l_pl p beta; inc_po_l C p\<rbrakk> \<Longrightarrow> (\<not> inc_po_pl C beta)"
and ax_D9b: "\<lbrakk>\<not> inc_l_pl p beta; \<not> int_l_pl p beta; inc_po_pl C beta\<rbrakk> \<Longrightarrow> (\<not> inc_po_l C p)"
and ax_D9: "\<lbrakk>\<not> inc_l_pl p beta; inc_po_l C p; inc_po_pl C beta\<rbrakk> \<Longrightarrow> (int_l_pl p beta)"
and ax_false_bet: "\<lbrakk>bet A B C; \<not> bet A B C\<rbrakk> \<Longrightarrow> (False)"
and ax_false_col: "\<lbrakk>col A B C; \<not> col A B C\<rbrakk> \<Longrightarrow> (False)"
and ax_false_cop: "\<lbrakk>cop A B C D; \<not> cop A B C D\<rbrakk> \<Longrightarrow> (False)"
and ax_false_inc_l_pl: "\<lbrakk>inc_l_pl p beta; \<not> inc_l_pl p beta\<rbrakk> \<Longrightarrow> (False)"
and ax_false_inc_po_l: "\<lbrakk>inc_po_l A q; \<not> inc_po_l A q\<rbrakk> \<Longrightarrow> (False)"
and ax_false_inc_po_pl: "\<lbrakk>inc_po_pl A beta; \<not> inc_po_pl A beta\<rbrakk> \<Longrightarrow> (False)"
and ax_false_int_l_l: "\<lbrakk>int_l_l p q; \<not> int_l_l p q\<rbrakk> \<Longrightarrow> (False)"
and ax_false_int_l_pl: "\<lbrakk>int_l_pl p beta; \<not> int_l_pl p beta\<rbrakk> \<Longrightarrow> (False)"
and ax_false_int_pl_pl: "\<lbrakk>int_pl_pl alpha beta; \<not> int_pl_pl alpha beta\<rbrakk> \<Longrightarrow> (False)"
and ax_I2: "\<lbrakk>A ~= B; inc_po_l A r; inc_po_l B r; inc_po_l A s; inc_po_l B s\<rbrakk> \<Longrightarrow> (r = s)"
and ax_I5: "\<lbrakk>\<not> col A B C; inc_po_pl A alpha1; inc_po_pl B alpha1; inc_po_pl C alpha1; inc_po_pl A beta1; inc_po_pl B beta1; inc_po_pl C beta1\<rbrakk> \<Longrightarrow> (alpha1 = beta1)"
and ax_I6: "\<lbrakk>A ~= B; inc_po_l A r; inc_po_l B r; inc_po_pl A alpha1; inc_po_pl B alpha1\<rbrakk> \<Longrightarrow> (inc_l_pl r alpha1)"
and ax_sym_col1: "\<lbrakk>col A B C\<rbrakk> \<Longrightarrow> (col B C A)"
and ax_sym_col2: "\<lbrakk>col A B C\<rbrakk> \<Longrightarrow> (col B A C)"
and ax_sym_col: "\<lbrakk>col A B C\<rbrakk> \<Longrightarrow> (col A C B \<and> col B A C \<and> col B C A \<and> col C A B \<and> col C B A)"
and ax_sym_cop1: "\<lbrakk>cop A B C D\<rbrakk> \<Longrightarrow> (cop B C D A)"
and ax_sym_cop2: "\<lbrakk>cop A B C D\<rbrakk> \<Longrightarrow> (cop B A C D)"
and ax_sym_cop: "\<lbrakk>cop A B C D\<rbrakk> \<Longrightarrow> (cop A B D C \<and> cop A C B D \<and> cop A C D B \<and> cop A D B C \<and> cop A D C B \<and> cop B A C D \<and> cop B A D C \<and> cop B C A D \<and> cop B C D A \<and> cop B D A C \<and> cop B D C A \<and> cop C A B D \<and> cop C A D B \<and> cop C B A D \<and> cop C B D A \<and> cop C D A B \<and> cop C D B A \<and> cop D A B C \<and> cop D A C B \<and> cop D B A C \<and> cop D B C A \<and> cop D C A B \<and> cop D C B A)"
and ax_sym_int_l_l: "\<lbrakk>int_l_l p q\<rbrakk> \<Longrightarrow> (int_l_l q p)"
and ax_sym_int_pl_pl: "\<lbrakk>int_pl_pl alpha beta\<rbrakk> \<Longrightarrow> (int_pl_pl beta alpha)"
and ax_sym_ncol1: "\<lbrakk>\<not> col A B C\<rbrakk> \<Longrightarrow> (\<not> col B C A)"
and ax_sym_ncol2: "\<lbrakk>\<not> col A B C\<rbrakk> \<Longrightarrow> (\<not> col B A C)"
and ax_sym_ncol: "\<lbrakk>\<not> col A B C\<rbrakk> \<Longrightarrow> (\<not> col A C B \<and> \<not> col B A C \<and> \<not> col B C A \<and> \<not> col C A B \<and> \<not> col C B A)"
and ax_sym_ncop1: "\<lbrakk>\<not> cop A B C D\<rbrakk> \<Longrightarrow> (\<not> cop B C D A)"
and ax_sym_ncop2: "\<lbrakk>\<not> cop A B C D\<rbrakk> \<Longrightarrow> (\<not> cop B A C D)"
and ax_sym_ncop: "\<lbrakk>\<not> cop A B C D\<rbrakk> \<Longrightarrow> (\<not> cop A B D C \<and> \<not> cop A C B D \<and> \<not> cop A C D B \<and> \<not> cop A D B C \<and> \<not> cop A D C B \<and> \<not> cop B A C D \<and> \<not> cop B A D C \<and> \<not> cop B C A D \<and> \<not> cop B C D A \<and> \<not> cop B D A C \<and> \<not> cop B D C A \<and> \<not> cop C A B D \<and> \<not> cop C A D B \<and> \<not> cop C B A D \<and> \<not> cop C B D A \<and> \<not> cop C D A B \<and> \<not> cop C D B A \<and> \<not> cop D A B C \<and> \<not> cop D A C B \<and> \<not> cop D B A C \<and> \<not> cop D B C A \<and> \<not> cop D C A B \<and> \<not> cop D C B A)"
and ax_sym_nint_l_l: "\<lbrakk>\<not> int_l_l p q\<rbrakk> \<Longrightarrow> (\<not> int_l_l q p)"
and ax_sym_nint_pl_pl: "\<lbrakk>\<not> int_pl_pl alpha beta\<rbrakk> \<Longrightarrow> (\<not> int_pl_pl beta alpha)"
and ax_branch_bet: "(bet A B C)\<or>(\<not> bet A B C)"
and ax_branch_col: "\<lbrakk>A ~= B; A ~= C; B ~= C\<rbrakk> \<Longrightarrow> (col A B C)\<or>(\<not> col A B C)"
and ax_branch_cop: "\<lbrakk>A ~= B; A ~= C; A ~= D; B ~= C; B ~= D; C ~= D\<rbrakk> \<Longrightarrow> (cop A B C D)\<or>(\<not> cop A B C D)"
and ax_branch_inc_l_pl: "(inc_l_pl p beta)\<or>(\<not> inc_l_pl p beta)"
and ax_branch_inc_po_l: "(inc_po_l A q)\<or>(\<not> inc_po_l A q)"
and ax_branch_inc_po_pl: "(inc_po_pl A beta)\<or>(\<not> inc_po_pl A beta)"
and ax_branch_int_l_l: "\<lbrakk>p ~= q\<rbrakk> \<Longrightarrow> (int_l_l p q)\<or>(\<not> int_l_l p q)"
and ax_branch_int_l_pl: "(int_l_pl p beta)\<or>(\<not> int_l_pl p beta)"
and ax_branch_int_pl_pl: "\<lbrakk>alpha ~= beta\<rbrakk> \<Longrightarrow> (int_pl_pl alpha beta)\<or>(\<not> int_pl_pl alpha beta)"
and ax_g1: "(A = B)\<or>(A ~= B)"
and ax_g2: "(p = q)\<or>(p ~= q)"
and ax_g3: "(alpha = beta)\<or>(alpha ~= beta)"
and ax_D10: "\<lbrakk>int_l_pl p beta\<rbrakk> \<Longrightarrow> \<exists>(C::point).(inc_po_l C p \<and> inc_po_pl C beta \<and> \<not> inc_l_pl p beta)"
and ax_D11a: "\<lbrakk>\<not> inc_l_pl p beta\<rbrakk> \<Longrightarrow> \<exists>(C::point).(inc_po_l C p \<and> \<not> inc_po_pl C beta)"
and ax_D2: "\<lbrakk>col A B C\<rbrakk> \<Longrightarrow> \<exists>(s::line).(inc_po_l A s \<and> inc_po_l B s \<and> inc_po_l C s)"
and ax_D4: "\<lbrakk>cop A B C D\<rbrakk> \<Longrightarrow> \<exists>(beta1::plane).(inc_po_pl A beta1 \<and> inc_po_pl B beta1 \<and> inc_po_pl C beta1 \<and> inc_po_pl D beta1)"
and ax_D6: "\<lbrakk>int_l_l p q\<rbrakk> \<Longrightarrow> \<exists>(C::point).(p ~= q \<and> inc_po_l C p \<and> inc_po_l C q)"
and ax_D8: "\<lbrakk>int_pl_pl alpha beta\<rbrakk> \<Longrightarrow> \<exists>(C::point).(alpha ~= beta \<and> inc_po_pl C alpha \<and> inc_po_pl C beta)"
and ax_I1: "\<lbrakk>A ~= B\<rbrakk> \<Longrightarrow> \<exists>(r::line).(inc_po_l A r \<and> inc_po_l B r)"
and ax_I3a: "\<exists>(B::point)(C::point).(B ~= C \<and> inc_po_l B p \<and> inc_po_l C p)"
and ax_I4a: "\<lbrakk>\<not> col A B C\<rbrakk> \<Longrightarrow> \<exists>(alpha1::plane).(inc_po_pl A alpha1 \<and> inc_po_pl B alpha1 \<and> inc_po_pl C alpha1)"
and ax_I4b: "\<exists>(B::point).(inc_po_pl B alpha)"
and ax_I7: "\<lbrakk>alpha ~= beta; inc_po_pl C alpha; inc_po_pl C beta\<rbrakk> \<Longrightarrow> \<exists>(D::point).(C ~= D \<and> inc_po_pl D alpha \<and> inc_po_pl D beta)"
and ax_I3b: "\<exists>(A::point)(B::point)(C::point).(\<not> col A B C)"
and ax_I8: "\<exists>(A::point)(B::point)(C::point)(D::point).(\<not> cop A B C D)"

lemma th_1_01 :  assumes  "\<not> inc_po_l A p"  shows "\<exists>(B::point)(C::point).(B ~= C \<and> inc_po_l B p \<and> inc_po_l C p)" 

proof - 

obtain B::point and C::point
  where "B ~= C" and "inc_po_l B p" and "inc_po_l C p"
  using ax_I3a [of "p"] 
  by auto 

from `B ~= C` and `inc_po_l B p` and `inc_po_l C p`
have ?thesis
  by auto 

from this
show ?thesis 
.
qed



lemma th_1_02 :  assumes  "\<not> inc_po_l A p" and "B ~= C" and "inc_po_l B p" and "inc_po_l C p"  shows "(\<not> col A B C)" 

proof - 

from `B ~= C` and `inc_po_l B p` and `inc_po_l C p` and `\<not> inc_po_l A p`
have "\<not> col B C A"
  by (rule ax_D1a)

from `\<not> col B C A`
have "\<not> col B A C" and "\<not> col C B A" and "\<not> col C A B" and "\<not> col A B C" and "\<not> col A C B"
  using ax_sym_ncol [of "B" "C" "A"] 
  by auto 

from `\<not> col A B C`
have ?thesis
  by assumption

from this
show ?thesis 
.
qed



lemma th_1_03 :  assumes  "\<not> inc_po_l A p" and "B ~= C" and "inc_po_l B p" and "inc_po_l C p" and "\<not> col A B C"  shows "\<exists>(alpha::plane).(inc_po_pl A alpha \<and> inc_po_pl B alpha \<and> inc_po_pl C alpha)" 

proof - 

from `\<not> col A B C`
obtain alpha::plane
  where "inc_po_pl A alpha" and "inc_po_pl B alpha" and "inc_po_pl C alpha"
  using ax_I4a [of "A" "B" "C"] 
  by auto 

from `inc_po_pl A alpha` and `inc_po_pl B alpha` and `inc_po_pl C alpha`
have ?thesis
  by auto 

from this
show ?thesis 
.
qed



lemma th_1_04 :  assumes  "\<not> inc_po_l A p" and "B ~= C" and "inc_po_l B p" and "inc_po_l C p" and "\<not> col A B C" and "inc_po_pl A alpha" and "inc_po_pl B alpha" and "inc_po_pl C alpha"  shows "(inc_l_pl p alpha \<and> inc_po_pl A alpha)" 

proof - 

from `B ~= C` and `inc_po_l B p` and `inc_po_l C p` and `inc_po_pl B alpha` and `inc_po_pl C alpha`
have "inc_l_pl p alpha"
  by (rule ax_I6)

from `inc_l_pl p alpha` and `inc_po_pl A alpha`
have ?thesis
  by -((rule conjI, assumption)+, assumption)

from this
show ?thesis 
.
qed

end

(*Transformed by Vernacular package (2018)*)